/*

*/

import renderer.scene.*;
import renderer.models.*;
import renderer.pipeline.*;
import renderer.framebuffer.*;

import java.awt.Color;

/**
   http://merganser.math.gvsu.edu/david/psseminar/index.html#jiggity
*/
public class ThreeDimensionalScene_R1
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render
      final Scene scene = new Scene();

      // Create several Model objects.
      final Model m1 = new Cube();
      final Model m2 = new Tetrahedron();
      final Model m3 = new Octahedron();
      final Model m4 = new Dodecahedron();
      final Model m5 = new Icosahedron();
      final Model m6 = new PanelXZ(-7, 7, -7, 7);

      // Add the models to the scene.
      scene.addModel(m1, m2, m3, m4, m5, m6);

      // Place each model in the scene in front of the camera.
      for (int i = 0; i < m6.vertexList.size(); ++i) // Panel
      {
         final Vertex v = m6.vertexList.get(i);
         m6.vertexList.set(i, new Vertex(v.x,
                                         v.y - 7,
                                         v.z - 14));
      }
      for (int i = 0; i < m1.vertexList.size(); ++i) // Cube
      {
         final Vertex v = m1.vertexList.get(i);
         m1.vertexList.set(i, new Vertex(v.x - 4,
                                         v.y,
                                         v.z - 18));
      }
      for (int i = 0; i < m2.vertexList.size(); ++i) //Tetrahedron
      {
         final Vertex v = m2.vertexList.get(i);
         m2.vertexList.set(i, new Vertex(v.x,
                                         v.y - 2,
                                         v.z - 14));
      }
      for (int i = 0; i < m3.vertexList.size(); ++i) // Octahedron
      {
         final Vertex v = m3.vertexList.get(i);
         m3.vertexList.set(i, new Vertex(v.x + 4,
                                         v.y - 3,
                                         v.z - 10));
      }
      for (int i = 0; i < m4.vertexList.size(); ++i) // Dodecahedron
      {
         final Vertex v = m4.vertexList.get(i);
         m4.vertexList.set(i, new Vertex(v.x - 4,
                                         v.y - 3,
                                         v.z - 10));
      }
      for (int i = 0; i < m5.vertexList.size(); ++i) // Icosahedron
      {
         final Vertex v = m5.vertexList.get(i);
         m5.vertexList.set(i, new Vertex(v.x + 4,
                                         v.y,
                                         v.z - 18));
      }

      // Create a framebuffer to render our scene into.
      final int width  = 800;
      final int height = 800;
      final FrameBuffer fb = new FrameBuffer(width, height);
      // Give the framebuffer a nice background color.
      fb.clearFB(Color.darkGray);

      // Render
      Pipeline.debug  = true;
      Pipeline.render(scene, fb.vp);

      // Save the framebuffer's data in an image file.
      fb.dumpFB2File("ThreeDimensionalScene_R1.ppm");
   }
}
